## castle-game-engine 7.0~alpha.1+dfsg

=== Makefile ===
# Makefile to build and perform other useful operations on the Castle Game Engine.
#
# Requires using GNU make.
# - On Linux and most other Unixes, just call "make".
# - On FreeBSD call "gmake".
# - On Windows, install Cygwin ( http://www.cygwin.com/ ) with "make" package.
#   Make sure that when you type "make" it executes Cygwin's "make":
#   Cygwin's directory (like c:/cygwin64/bin/) should be on $PATH environment variable
#   *before* other directories with "make" implementations, like
#   - FPC directory that includes "make" from MinGW (it is GNU make but cannot execute bash scripts)
#   - Delphi directory that includes Embarcadero "make" (it's not GNU make and will fail).
#
# Most useful targets of this Makefile:
#
#   all (default target) --
#     Compile all units, uses fpmake.
#
#   examples --
#     Compile most examples and tools (that don't use Lazarus LCL).
#     Lazarus is not required (LCL dependent examples are not compiled).
#
#     This compilation method calls our "build tool" to compile examples
#     and other tools (build tool, in turn, calls a compiler like FPC or Delphi).
#
#     The exception is when compiling the "build tool" itself,
#     then we call FPC directly. (Although we *could* use
#     the "build tool" to compile (bootstrap) itself, but it's not what
#     people expect by default, so we don't do it for now.)
#
#   examples-laz --
#     Compile all examples and tools using Lazarus.
#     This compilation method uses our .lpi project files,
#     and compiles every program by the lazbuild utility.
#     Lazarus and FPC installation is required, and Lazarus must know
#     about the castle_* packages (compile them from Lazarus first).
#
#   clean --
#     Delete FPC temporary files, Delphi temporary files,
#     Lazarus temporary files (*.compiled),
#     binaries of example programs and tools.
#
# Not-so-commonly-useful targets:
#
#   cleanmore --
#     Same as clean, but also delete:
#     - Backup files from Emacs (*~), Lazarus (backup), Delphi (*.~???), Blender,
#       QtCreator (*.pro.user)...
#     - pasdoc generated documentation in doc/pasdoc/ and doc/reference/
#     - closed-source libs you may have left in tools/build-tool/data
#     This is a useful step when packing the release of CGE.
#
#   cleanall --
#     Same as cleanmore for now.
#     Intention is to remove *everything* that can be manually recreated,
#     even if it's somewhat hard to recreate.

# detect platform-specific things --------------------------------------------

# FIND := Unix/Cygwin "find" utility (*not* Windows "find" command which has completely different use)
# SED := GNU sed (*not* other sed implementations)
# EXE_EXTENSION := extension of executable files (with leading dot, if any)

SED := sed
FIND := find
EXE_EXTENSION :=

ifeq ($(OS),Windows_NT)
  # On Windows avoid using Windows built-in "find" program. Use the Cygwin "find".
  FIND := `cygpath --mixed /bin/find`
  EXE_EXTENSION := .exe
else
  # Only on Unix, you can use "uname" to further detect Unix variants,
  # see https://stackoverflow.com/questions/714100/os-detecting-makefile
  UNAME_S := $(shell uname -s)
  # On macOS, use gsed (e.g. from Homebrew)
  ifeq ($(UNAME_S),Darwin)
    SED := gsed
  endif
endif

# compile ------------------------------------------------------------

.PHONY: all
all:
	$(MAKE) --no-print-directory build-using-fpmake
	$(MAKE) tools

.PHONY: tools
tools:
# Compile build tool first, used to compile other tools and examples
	tools/build-tool/castle-engine_compile.sh
	tools/texture-font-to-pascal/texture-font-to-pascal_compile.sh
	tools/image-to-pascal/image-to-pascal_compile.sh
	tools/castle-curves/castle-curves_compile.sh
	tools/to-data-uri/to-data-uri_compile.sh

.PHONY: build-using-fpmake
build-using-fpmake:
	fpc fpmake.pp
	@echo 'Running fpmake. If this fails saying that "rtl" is not found, remember to set FPCDIR environment variable, see http://wiki.freepascal.org/FPMake .'
# Workaround FPC >= 3.x problem (bug?) --- it ignores $FPCDIR, but --globalunitdir works
	if [ '(' -n "$(FPCDIR)" ')' ]; then \
	   ./fpmake --globalunitdir="$(FPCDIR)"; \
	else \
	   ./fpmake; \
	fi

# Full test that fpmake compilation process works
# (see https://github.com/castle-engine/castle-engine/wiki/FpMake )
.PHONY: test-fpmake
test-fpmake: build-using-fpmake
# Test fpmake with --nofpccfg, to make sure our dependencies in fpmake.pp are correct
	./fpmake clean --verbose
	if [ '(' -n "$(FPCDIR)" ')' ]; then \
	   ./fpmake --globalunitdir="$(FPCDIR)" --nofpccfg --verbose; \
	else \
	   ./fpmake --nofpccfg --verbose; \
	fi

# install / uninstall --------------------------------------------------------
#
# Note that this *does not* take care of installing the unit files.
# So it does not copy .ppu/.o files, it does not change your /etc/fpc.cfg
# or ~/.fpc.cfg. There are many ways how to install unit files,
# we leave this step up to you.
# See https://castle-engine.io/engine.php for documentation.
#
# Below we only take care of installing the tools.
# By default they are installed system-wide to /usr/local ,
# so you can run "make" followed by "sudo make install" to have the tools
# ready on a typical Unix system.

# Standard installation dirs, following conventions on
# http://www.gnu.org/prep/standards/html_node/Directory-Variables.html#Directory-Variables
PREFIX=$(DESTDIR)/usr/local
EXEC_PREFIX=$(PREFIX)
BINDIR=$(EXEC_PREFIX)/bin
DATAROOTDIR=$(PREFIX)/share
DATADIR=$(DATAROOTDIR)

.PHONY: install
install:
	install -d $(BINDIR)
	install tools/texture-font-to-pascal/texture-font-to-pascal$(EXE_EXTENSION) $(BINDIR)
	install tools/image-to-pascal/image-to-pascal$(EXE_EXTENSION) $(BINDIR)
	install tools/castle-curves/castle-curves$(EXE_EXTENSION) $(BINDIR)
	install tools/build-tool/castle-engine$(EXE_EXTENSION) $(BINDIR)
	install tools/to-data-uri/to-data-uri$(EXE_EXTENSION) $(BINDIR)
#	cp -R tools/build-tool/data $(DATADIR)/castle-engine
	install -d  $(DATADIR)
	cd tools/build-tool/data/ && \
	  $(FIND) . -type f -exec install --mode 644 -D '{}' $(DATADIR)/castle-engine/'{}' ';'

.PHONY: uninstall
uninstall:
	rm -f  $(BINDIR)/texture-font-to-pascal$(EXE_EXTENSION) \
	       $(BINDIR)/image-to-pascal$(EXE_EXTENSION) \
	       $(BINDIR)/castle-curves$(EXE_EXTENSION) \
	       $(BINDIR)/castle-engine$(EXE_EXTENSION) \
	       $(BINDIR)/to-data-uri$(EXE_EXTENSION)
	rm -Rf $(DATADIR)/castle-engine

# Strip libraries that cannot be distributed in Debian package of CGE.
# - Some of them (some bundled Windows, Android libs) cannot be recompiled
#   automatically and easily for now (although they are open-source),
#   and are not of sufficient interest to the Debian users.
# - Some (Gradle) should be better used by depending on
#   the appropriate Debian package.
.PHONY: strip-precompiled-libraries
strip-precompiled-libraries:
	rm -Rf tools/build-tool/data/external_libraries/ \
	       tools/build-tool/data/android/integrated-services/sound/ \
	       tools/build-tool/data/android/integrated-services/ogg_vorbis/ \
	       tools/build-tool/data/android/base/gradle/ \
	       tools/build-tool/data/android/base/gradlew \
	       tools/build-tool/data/android/base/gradlew.bat \
	       tools/build-tool/data/android/integrated/gradle/ \
	       tools/build-tool/data/android/integrated/gradlew \
	       tools/build-tool/data/android/integrated/gradlew.bat

# examples and tools -----------------------------------------------------------

# Note that images/examples/fft_tests is not included here,
# and unit images/imagesfftw.pas is not included in fpmake.pp,
# because
# 1. it requires to compile FPC > 2.2.x, and we try to work also with earlier FPC.
# 2. to link the example, you need the fftw library. I don't want
#    to force everyone who wants to execute "make examples" to install
#    fftw library (especially since it's really not needed by my engine,
#    currently my fftw code is just for testing, it's not actually used
#    by our engine or any game for anything).
#
# Note that examples with CastleEngineManifest.xml are not listed here.
# They will be found and compiled by a Makefile rule that searches using
# "find ... -iname CastleEngineManifest.xml ..." .
#
# TODO: In the long run, it would be best if *all* examples had CastleEngineManifest.xml,
# then the need to maintain EXAMPLES_BASE_NAMES would disappear.

EXAMPLES_BASE_NAMES := \
  examples/3d_rendering_processing/animate_3d_model_by_code \
  examples/3d_rendering_processing/animate_3d_model_by_code_2 \
  examples/3d_rendering_processing/build_3d_object_by_code \
  examples/3d_rendering_processing/build_3d_tunnel \
  examples/3d_rendering_processing/call_pascal_code_from_3d_model_script \
  examples/3d_rendering_processing/cars_demo \
  examples/3d_rendering_processing/combine_multiple_x3d_into_one \
  examples/3d_rendering_processing/custom_input_shortcuts_saved_to_config \
  examples/3d_rendering_processing/detect_scene_clicks \
  examples/3d_rendering_processing/display_box_custom_shaders \
  examples/3d_rendering_processing/fog_culling \
  examples/3d_rendering_processing/listen_on_x3d_events \
  examples/3d_rendering_processing/multiple_viewports \
  examples/3d_rendering_processing/placeholder_names \
  examples/3d_rendering_processing/render_3d_to_image \
  examples/3d_rendering_processing/render_3d_to_texture_and_use_as_quad \
  examples/3d_rendering_processing/transform_scenes_demos \
  examples/3d_rendering_processing/show_bounding_rect_in_2d \
  examples/3d_rendering_processing/switch_projection \
  examples/3d_rendering_processing/triangulate_demo \
  examples/3d_rendering_processing/view_3d_model_advanced \
  examples/3d_rendering_processing/view_3d_model_basic \
  examples/castlescript/castle_calculator \
  examples/castlescript/image_make_by_script \
  examples/curves/simplest_curve_read \
  examples/fonts/font_draw_over_image \
  examples/fonts/font_from_texture \
  examples/fonts/test_font_break \
  examples/images_videos/background_tiling \
  examples/images_videos/dds_decompose \
  examples/images_videos/draw_images_on_gpu \
  examples/images_videos/drawing_modes_test \
  examples/images_videos/image_compare \
  examples/images_videos/image_convert \
  examples/images_videos/image_identify \
  examples/images_videos/image_paint \
  examples/images_videos/image_render_custom_shader \
  examples/images_videos/simple_video_editor \
  examples/images_videos/test_castleimage_draw3x3 \
  examples/random_generator/globalrandom \
  examples/random_generator/random_speed_test \
  examples/random_generator/random_threads_test \
  examples/research_special_rendering_methods/radiance_transfer/precompute_radiance_transfer \
  examples/research_special_rendering_methods/radiance_transfer/radiance_transfer \
  examples/research_special_rendering_methods/radiance_transfer/show_sh \
  examples/simple_command_line_utilities/dircleaner \
  examples/simple_command_line_utilities/stringoper \
  examples/space_filling_curve/draw_space_filling_curve \
  examples/window/multi_window \
  examples/window/window_events \
  examples/window/window_menu \
  tools/castle-curves/castle-curves \
  tools/image-to-pascal/image-to-pascal \
  tools/internal/generate-persistent-vectors/generate-persistent-vectors \
  tools/internal/teapot-to-pascal/teapot-to-pascal \
  tools/internal/x3d-nodes-to-pascal/code/x3d-nodes-to-pascal \
  tools/texture-font-to-pascal/texture-font-to-pascal \
  tools/to-data-uri/to-data-uri

# Note that src/library/castleengine must be compiled before
# cge_dynlib_tester, otherwise linking cge_dynlib_tester will fail.
EXAMPLES_LAZARUS_BASE_NAMES := \
  examples/lazarus/load_model_and_camera_manually/load_model_and_camera_manually \
  examples/lazarus/model_3d_viewer/model_3d_viewer \
  examples/lazarus/model_3d_with_2d_controls/model_3d_with_2d_controls \
  examples/lazarus/quick_2d_game/quick_2d_game_lazarus \
  examples/lazarus/two_controls/two_controls \
  src/library/castleengine \

=== doc/pasdoc/Makefile ===
# Main targets to gen final docs ----------------------------------------

.PHONY: default html pdf ps rtf latex

# html is shown on https://castle-engine.io/apidoc/html/
default: html

# Run "make" in logo/ first,
# if you have inkscape installed,
# and you want to regenerate logo from png.
#
# Run "make" in html-parts/ first,
# if you have cge-www repository (https://github.com/castle-engine/cge-www)
# cloned and placed as a sibling to castle-engine, in ../../../cge-www/

html:
	./mk_docs.sh html
# For quick testing of docs look (CSS etc.), you can run this instead
#	./mk_docs.sh html base/castleutils.pas
	rm -Rf ../reference/
	mv html ../reference/
	cp -R logo/castle_game_engine_icon.png \
	      html-parts/images/ \
	      html-parts/castle-engine-website-base/ \
	      html-parts/cge-pasdoc.js \
	      ../reference/

# Just some shortcuts to "Helpful targets" below
pdf: latex/docs.pdf
ps: latex/docs.ps
rtf: latex2rtf/docs.rtf
latex: latex/docs.tex

# Helpful targets to gen docs ----------------------------------------

latex2rtf/docs.tex:
	./mk_docs.sh latex2rtf

latex2rtf/docs.rtf: latex2rtf/docs.tex
	cd latex2rtf; latex2rtf docs.tex

latex/docs.tex:
	./mk_docs.sh latex

TEX_BATCH_OPTS := --file-line-error-style -interaction=nonstopmode

latex/docs.dvi: latex/docs.tex
	-cd latex; latex $(TEX_BATCH_OPTS) docs.tex
	-cd latex; latex $(TEX_BATCH_OPTS) docs.tex

# At the end of pdf generating, we clean useless junk
# (because it's quite large, and I may want to upload latex/
# dir to WWW page of my units)
latex/docs.pdf: latex/docs.tex
	-cd latex; pdflatex $(TEX_BATCH_OPTS) docs.tex
	-cd latex; pdflatex $(TEX_BATCH_OPTS) docs.tex
	rm -f latex/docs.aux \
	      latex/docs.log \
	      latex/docs.out \
	      latex/docs.toc

latex/docs.ps: latex/docs.dvi
	cd latex; dvips docs.dvi -o docs.ps

# Cleaning ------------------------------------------------------------

.PHONY: clean-cache clean

clean-cache:
	rm -fR cache/

clean: clean-cache
	rm -Rf html/ latex/ latex2rtf/ ../reference/

# upload ---------------------------------------------------------------------

SSH_USERNAME=michalis
SSH_HOST=ssh.castle-engine.io
SSH_PATH=/home/michalis/cge-html/apidoc/
# Use this for unstable docs:
#SSH_PATH=/home/michalis/cge-html/apidoc-unstable/

# Prepare and upload all the stuff referenced under
# https://castle-engine.io/apidoc/html/ .
# Uploads as tar.gz and unpacks on server, this is *much* faster than
# uploading separate HTML files.
.PHONY: upload
upload: clean html
	rm -Rf ../reference/html
	mv ../reference/ html
	tar czf html.tar.gz html
	scp -r html.tar.gz $(SSH_USERNAME)@$(SSH_HOST):$(SSH_PATH)
	rm -f html.tar.gz
	./ssh_upload_finalize.sh $(SSH_USERNAME) $(SSH_HOST) $(SSH_PATH)

=== examples/2d_dragon_spine_game/Makefile ===
# This Makefile uses castle-engine build tool for most operations.
# See https://github.com/castle-engine/castle-engine/wiki/Build-Tool .

MODE:=debug

.PHONY: compile
compile:
	castle-engine --mode=$(MODE)  compile $(CASTLE_ENGINE_TOOL_OPTIONS)

.PHONY: clean
clean:
	castle-engine clean

.PHONY: win32
win32:
	castle-engine --mode=$(MODE) package --os=win32 --cpu=i386

.PHONY: linux
linux:
	castle-engine --mode=$(MODE) package --os=linux --cpu=i386

.PHONY: src
src:
	castle-engine --mode=$(MODE) package-source

.PHONY: android
android:
	castle-engine --mode=$(MODE) package --target=android --fast
	castle-engine install --target=android
	castle-engine run --target=android

.PHONY: android-release
android-release:
	castle-engine clean
	$(MAKE) android MODE=release

.PHONY: ios
ios:
	castle-engine --mode=$(MODE) package --target=iOS --fast

.PHONY: ios-release
ios-release:
	castle-engine clean
	$(MAKE) ios MODE=release

# nx -------------------------------------------------------------------------

NX_OUTPUT_PATH:=d:/tmp/dragon_spine/

.PHONY: nx1
nx1:
	mkdir -p $(NX_OUTPUT_PATH)
	castle-engine package --mode=$(MODE) --target=nintendo-switch --output=$(NX_OUTPUT_PATH) --fast

.PHONY: nx2
nx2:
	mkdir -p $(NX_OUTPUT_PATH)
	castle-engine compile --mode=$(MODE) --target=nintendo-switch --output=$(NX_OUTPUT_PATH)

=== examples/fps_game/Makefile ===
# This Makefile uses castle-engine build tool for most operations.
# See https://github.com/castle-engine/castle-engine/wiki/Build-Tool .

MODE:=debug

.PHONY: default
default: prebuild
	castle-engine compile

.PHONY: prebuild
prebuild:
	castle-engine auto-generate-textures

.PHONY: standalone
standalone: prebuild
	castle-engine --mode=$(MODE) compile $(CASTLE_ENGINE_TOOL_OPTIONS)

.PHONY: clean
clean:
	castle-engine clean

.PHONY: win32
win32: prebuild
	castle-engine --mode=$(MODE) package --os=win32 --cpu=i386

.PHONY: win64
win64: prebuild
	castle-engine --mode=$(MODE) package --os=win64 --cpu=x86_64

.PHONY: linux32
linux32: prebuild
	castle-engine --mode=$(MODE) package --os=linux --cpu=i386

.PHONY: linux64
linux64: prebuild
	castle-engine --mode=$(MODE) package --os=linux --cpu=x86_64

.PHONY: src
src:
	castle-engine --mode=$(MODE) package-source

.PHONY: android
android: prebuild
	castle-engine --mode=$(MODE) package --target=android --fast
	castle-engine install --target=android
	castle-engine run --target=android

.PHONY: android-release
android-release: prebuild
	castle-engine clean
	$(MAKE) android MODE=release

.PHONY: ios
ios: prebuild
	castle-engine --mode=$(MODE) package --target=iOS --fast

.PHONY: ios-release
ios-release: prebuild
	castle-engine clean
	$(MAKE) ios MODE=release

=== examples/isometric_game/Makefile ===
# This Makefile uses castle-engine build tool for most operations.
# See https://github.com/castle-engine/castle-engine/wiki/Build-Tool .

MODE:=debug

.PHONY: standalone
standalone:
	castle-engine --mode=$(MODE) compile $(CASTLE_ENGINE_TOOL_OPTIONS)

.PHONY: clean
clean:
	castle-engine clean

.PHONY: win32
win32:
	castle-engine --mode=$(MODE) package --os=win32 --cpu=i386

.PHONY: linux32
linux32:
	castle-engine --mode=$(MODE) package --os=linux --cpu=i386

.PHONY: linux64
linux64:
	castle-engine --mode=$(MODE) package --os=linux --cpu=x86_64

.PHONY: src
src:
	castle-engine --mode=$(MODE) package-source

.PHONY: android
android:
	castle-engine --mode=$(MODE) package --target=android --fast
	castle-engine install --target=android
	castle-engine run --target=android

.PHONY: android-release
android-release:
	castle-engine clean
	$(MAKE) android MODE=release

.PHONY: ios
ios:
	castle-engine --mode=$(MODE) package --target=iOS --fast

.PHONY: ios-release
ios-release:
	castle-engine clean
	$(MAKE) ios MODE=release

=== examples/joystick/Makefile ===
# This Makefile uses castle-engine build tool for most operations.
# See https://github.com/castle-engine/castle-engine/wiki/Build-Tool .

MODE:=debug

.PHONY: compile
compile:
	castle-engine --mode=$(MODE) compile $(CASTLE_ENGINE_TOOL_OPTIONS)

.PHONY: clean
clean:
	castle-engine clean

.PHONY: win32
win32:
	castle-engine --mode=$(MODE) package --os=win32 --cpu=i386

.PHONY: win64
win64:
	castle-engine --mode=$(MODE) package --os=win64 --cpu=x86_64

.PHONY: linux32
linux32:
	castle-engine --mode=$(MODE) package --os=linux --cpu=i386

.PHONY: linux64
linux64:
	castle-engine --mode=$(MODE) package --os=linux --cpu=x86_64

.PHONY: src
src:
	castle-engine --mode=$(MODE) package-source

.PHONY: android
android:
	castle-engine --mode=$(MODE) package --target=android --fast
	castle-engine install --target=android
	castle-engine run --target=android

.PHONY: ios
ios:
	castle-engine --mode=$(MODE) package --target=iOS --fast

# nx -------------------------------------------------------------------------

NX_OUTPUT_PATH:=d:/tmp/joystick_demo/

.PHONY: nx1
nx1:
	mkdir -p $(NX_OUTPUT_PATH)
	castle-engine package --mode=$(MODE) --target=nintendo-switch --output=$(NX_OUTPUT_PATH) --fast

.PHONY: nx2
nx2:
	mkdir -p $(NX_OUTPUT_PATH)
	castle-engine compile --mode=$(MODE) --target=nintendo-switch --output=$(NX_OUTPUT_PATH)

=== doc/pasdoc/html-parts/Makefile ===
# Use this Makefile to generate HTML files
# for inclusion in the HTML API documentation.
#
# It requires
# - command-line php
# - cge-www repository (https://github.com/castle-engine/cge-www)
#   cloned and placed as a sibling to castle-engine, in ../../../../cge-www/

ALL_TARGETS := body-end.html body-begin.html head.html images castle-engine-website-base

.PHONY: default
default: $(ALL_TARGETS)

.PHONY: clean
clean:
	rm -Rf $(ALL_TARGETS)

%.html: %.php
	php $< > $@

# Copy some static things (images, CSS, JS files) from cge-www.

CGE_WWW_PATH := ../../../../cge-www/

images:
	mkdir -p images
	cp -f $(CGE_WWW_PATH)htdocs/images/header_icon.png \
	      $(CGE_WWW_PATH)htdocs/images/patreonlogoorange_45px.png \
	      images/

castle-engine-website-base:
	mkdir -p castle-engine-website-base
	cp -Rf $(CGE_WWW_PATH)htdocs/castle-engine-website-base/castle-engine.css \
	       $(CGE_WWW_PATH)htdocs/castle-engine-website-base/castle-engine.js \
	       $(CGE_WWW_PATH)htdocs/castle-engine-website-base/bootstrap \
	       $(CGE_WWW_PATH)htdocs/castle-engine-website-base/colorbox \
	       $(CGE_WWW_PATH)htdocs/castle-engine-website-base/js \
	       castle-engine-website-base/

=== examples/animations/play_animation/Makefile ===
# This Makefile uses castle-engine build tool for most operations.
# See https://github.com/castle-engine/castle-engine/wiki/Build-Tool .

.PHONY: standalone
standalone:
	castle-engine compile $(CASTLE_ENGINE_TOOL_OPTIONS)

.PHONY: clean
clean:
	castle-engine clean

.PHONY: release-src
release-src:
	castle-engine package-source

.PHONY: release-win32
release-win32:
	castle-engine package --os=win32 --cpu=i386

.PHONY: release-linux
release-linux:
	castle-engine package --os=linux --cpu=i386

.PHONY: release-linux64
release-linux64:
	castle-engine package --os=linux --cpu=x86_64

.PHONY: android
android:
	castle-engine package --target=android --fast --mode=debug
	castle-engine install --target=android
	castle-engine run --target=android

.PHONY: release-android
release-android:
	castle-engine package --target=android --mode=release
	castle-engine install --target=android

=== examples/audio/play_sounds/Makefile ===
# This Makefile uses castle-engine build tool for most operations.
# See https://github.com/castle-engine/castle-engine/wiki/Build-Tool .

MODE:=debug

.PHONY: compile
compile:
	castle-engine --mode=$(MODE) compile $(CASTLE_ENGINE_TOOL_OPTIONS)

.PHONY: clean
clean:
	castle-engine clean

.PHONY: win32
win32:
	castle-engine --mode=$(MODE) package --os=win32 --cpu=i386

.PHONY: win64
win64:
	castle-engine --mode=$(MODE) package --os=win64 --cpu=x86_64

.PHONY: linux32
linux32:
	castle-engine --mode=$(MODE) package --os=linux --cpu=i386

.PHONY: linux64
linux64:
	castle-engine --mode=$(MODE) package --os=linux --cpu=x86_64

.PHONY: src
src:
	castle-engine --mode=$(MODE) package-source

.PHONY: android
android:
	castle-engine --mode=$(MODE) package --target=android --fast
	castle-engine install --target=android
	castle-engine run --target=android

.PHONY: ios
ios:
	castle-engine --mode=$(MODE) package --target=iOS --fast

# nx -------------------------------------------------------------------------

NX_OUTPUT_PATH:=d:/tmp/play_sounds/

.PHONY: nx1
nx1:
	mkdir -p $(NX_OUTPUT_PATH)
	castle-engine package --mode=$(MODE) --target=nintendo-switch --output=$(NX_OUTPUT_PATH) --fast

.PHONY: nx2
nx2:
	mkdir -p $(NX_OUTPUT_PATH)
	castle-engine compile --mode=$(MODE) --target=nintendo-switch --output=$(NX_OUTPUT_PATH)

=== examples/mobile/drawing_toy/Makefile ===
# This Makefile uses castle-engine build tool for most operations.
# See https://github.com/castle-engine/castle-engine/wiki/Build-Tool .

MODE:=debug

.PHONY: standalone
standalone:
	castle-engine --mode=$(MODE) compile $(CASTLE_ENGINE_TOOL_OPTIONS)

.PHONY: clean
clean:
	castle-engine clean

.PHONY: android
android:
	castle-engine --mode=$(MODE) package --target=android --fast
	castle-engine install --target=android
	castle-engine run --target=android

.PHONY: ios
ios:
	castle-engine --mode=$(MODE) package --target=iOS --fast

=== examples/mobile/test_bump_mapping/Makefile ===
# This Makefile uses castle-engine build tool for most operations.
# See https://github.com/castle-engine/castle-engine/wiki/Build-Tool .

.PHONY: standalone
standalone:
	castle-engine compile --mode=debug $(CASTLE_ENGINE_TOOL_OPTIONS)

.PHONY: clean
clean:
	castle-engine clean

.PHONY: android
android:
	castle-engine package --target=android --fast --mode=debug
	castle-engine install --target=android
	castle-engine run --target=android

=== examples/network/custom_url_handler/Makefile ===
# This Makefile uses castle-engine build tool for most operations.
# See https://github.com/castle-engine/castle-engine/wiki/Build-Tool .

MODE:=debug

.PHONY: compile
compile:
	castle-engine --mode=$(MODE) compile $(CASTLE_ENGINE_TOOL_OPTIONS)

.PHONY: clean
clean:
	castle-engine clean

.PHONY: win32
win32:
	castle-engine --mode=$(MODE) package --os=win32 --cpu=i386

.PHONY: win64
win64:
	castle-engine --mode=$(MODE) package --os=win64 --cpu=x86_64

.PHONY: linux32
linux32:
	castle-engine --mode=$(MODE) package --os=linux --cpu=i386

.PHONY: linux64
linux64:
	castle-engine --mode=$(MODE) package --os=linux --cpu=x86_64

.PHONY: src
src:
	castle-engine --mode=$(MODE) package-source

.PHONY: android
android:
	castle-engine --mode=$(MODE) package --target=android --fast
	castle-engine install --target=android
	castle-engine run --target=android

.PHONY: ios
ios:
	castle-engine --mode=$(MODE) package --target=iOS --fast

=== debian/changelog ===
castle-game-engine (7.0~alpha.1+dfsg-9) unstable; urgency=medium

  * Update Build-Depends to use libgdk-pixbuf-2.0-dev instead of
    libgdk-pixbuf2.0-dev (Closes: #1019310)
  * Fix several packaging issues (thanks lintian)

 -- Paul Gevers <elbrus@debian.org>  Thu, 08 Sep 2022 19:19:16 +0200

=== debian/control ===
Source: castle-game-engine
Section: misc
Priority: optional
Maintainer: Pascal Packaging Team <pkg-pascal-devel@lists.alioth.debian.org>
Uploaders:
 Abou Al Montacir <abou.almontacir@sfr.fr>,
 Paul Gevers <elbrus@debian.org>
Standards-Version: 4.5.0
Build-Depends:
 debhelper-compat (= 13),
 dh-exec,
 fonts-dejavu,
 fp-compiler,
 fp-units-base,
 fp-units-db,
 fp-units-fcl,
 fp-units-gfx,
 fp-units-gtk2,
 fp-units-misc,
 fp-units-multimedia,
 fp-units-net,
 fp-utils (>= 2.6.2),
 help2man,
 imagemagick-6.q16,
 libatk1.0-dev,
 libcairo2-dev,
 libfreetype6-dev,
 libgdk-pixbuf-2.0-dev,
 libgl1,
 libgtk2.0-dev,
 libpango1.0-dev,
Build-Depends-Indep:
 inkscape (>= 1.0~),
 pasdoc (>= 0.16.0~),
Vcs-Git: https://salsa.debian.org/pascal-team/castle-game-engine.git
Vcs-Browser: https://salsa.debian.org/pascal-team/castle-game-engine
Homepage: https://castle-engine.sourceforge.io/engine.php
Rules-Requires-Root: no

Package: fp-units-castle-game-engine
Architecture: any
Depends:
 ${fpc-abi:Depends},
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 castle-game-engine-doc,
 fpc,
 lazarus
Suggests:
 castle-game-engine-src,
 gradle,
Description: Castle Game Engine - 3D game engine for FreePascal / Lazarus
 Castle Game Engine is a set of LGPL licenced libraries that are intended to
 ease developing 3D games with FreePascal / Lazarus.
 .
 It provides an excellent support for the VRML / X3D 3D data format. Other 3D
 formats are also supported.
 .
 It features many advanced graphic effects and easy to use API on top of OpenGL.
 .
 This package contains the FPC units and the auxiliary tools castle-curves,
 castle-engine, image-to-pascal, sprite-sheet-to-x3d, and
 texture-font-to-pascal.
 .
 This package suggests the gradle package. Gradle is only necessary if one
 wants to build Android applications, otherwise one can ignore that
 suggestion. Note that, in order to create Android applications, one will also
 need the Android SDK and NDK, and FPC cross-compiler, see
 https://github.com/castle-engine/castle-engine/wiki/Android.

Package: castle-game-engine-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends},
 fonts-droid-fallback,
 fonts-dejavu-core,
Suggests:
 castle-game-engine-src,
 fp-units-castle-game-engine,
 libjs-bootstrap,
 libjs-jquery,
Multi-Arch: foreign
Description: Castle Game Engine - Developer's Documentation
 Castle Game Engine is a set of LGPL licenced libraries that are intended to
 ease developing 3D games with FreePascal / Lazarus.
 .
 It provides an excellent support for the VRML / X3D 3D data format. Other 3D
 formats are also supported.
 .
 It features many advanced graphic effects and easy to use API on top of OpenGL.
 .
 This package contains documentation.

Package: castle-game-engine-src
Section: doc
Architecture: all
Depends:
 fonts-dejavu,
 ${misc:Depends}
Recommends:
 castle-game-engine-doc,
 fpc,
 lazarus
Suggests:
 fp-units-castle-game-engine
Multi-Arch: foreign
Description: Castle Game Engine - Source code for Lazarus integration
 Castle Game Engine is a set of LGPL licenced libraries that are intended to
 ease developing 3D games with FreePascal / Lazarus.
 .
 It provides an excellent support for the VRML / X3D 3D data format. Other 3D
 formats are also supported.
 .
 It features many advanced graphic effects and easy to use API on top of OpenGL.
 .
 This package contains source code for integration with Lazarus RAD IDE.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for Castle Game Engine

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk
export DH_ALWAYS_EXCLUDE := COPYING:LICENSE
export LANG:=C

# Documentation type to use chm/html
ifeq (${DEBDOCTYPE},)
DOCTYPE=html
# HTML Converter chmdocs or htmldocs for (default)
CONVERTER=${DOCTYPE}docs
else
DOCTYPE=${DEBDOCTYPE}
CONVERTER=${DOCTYPE}docs
endif
# Define FPC
ifndef FPC
FPC=/usr/bin/fpc
endif
# Set FPCVER
FPCVER=$(shell ${FPC} -iV)
# Define units installation default directory
export FPCDIR=/usr/lib/${DEB_HOST_MULTIARCH}/fpc/$(FPCVER)

CPU_TARGET?=$(shell ${FPC} -iTP)
OS_TARGET?=$(shell ${FPC} -iTO)
FPCTARGET=${CPU_TARGET}-${OS_TARGET}
# Used in dh-exec enhanced files
export CGE_VERSION=$(shell echo ${DEB_VERSION_UPSTREAM} | sed -e 's/^\([0-9\.]*\).*/\1/')
DEB_BUILD=$(lastword $(subst -, ,${DEB_VERSION}))
ifndef PACKAGESUFFIX
PACKAGESUFFIX=-${CGE_VERSION}
endif
# Get directories
INSTALL_DIR=$(CURDIR)/debian/tmp
LIB_DIR=${INSTALL_DIR}/usr/lib/${DEB_SOURCE}/${CGE_VERSION}
SRC_DIR=$(CURDIR)/debian/src/${DEB_SOURCE}-${CGE_VERSION}
UNITS_DIR=${INSTALL_DIR}/${FPCDIR}/units/${DEB_SOURCE}
TMP_DIR=${INSTALL_DIR}/tmp
# Get utils
ifndef MKDIR
MKDIR=mkdir -p
endif
ifndef CP
CP=cp -Rfpl
endif
RM:=rm -rf

#export DH_VERBOSE=1

%:
	dh ${@}

override_dh_auto_clean:
	${MAKE} cleanall
	$(MAKE) strip-precompiled-libraries
	dh_auto_clean

prepare-source: prepare-source-stamp
prepare-source-stamp:
	# Building Pascal style font file first while making sure that
	# no unit or object files polute the source tree
	${MKDIR} ${TMP_DIR}
	${FPC} -FE${TMP_DIR}  @castle-fpc.cfg tools/texture-font-to-pascal/texture-font-to-pascal.lpr
	cd src/fonts ; PATH=${PATH}:${TMP_DIR} ./mk_fonts.sh

	# cge embeds some images from xcf via png into Pascal source files
	# First we need to create the pngs
	for pngfile in $$(grep \\\.png\$$ debian/clean) ; do convert -layers flatten -background transparent $${pngfile%.png}.xcf $${pngfile} ; done
	# Then we build the helper function
	${FPC} -FE${TMP_DIR} -dRELEASE @castle-fpc.cfg tools/image-to-pascal/image-to-pascal.lpr
	# To finally convert png files to pas file
	PATH=${TMP_DIR} ${MAKE} -C src/ui/opengl/gui-images all

	# Upstream source contains auto-generated include files. Let's generate
	# them again.
	${FPC} -FE${TMP_DIR} -dRELEASE @castle-fpc.cfg \
		tools/internal/x3d-nodes-to-pascal/code/x3d-nodes-to-pascal.lpr
	cd tools/internal/x3d-nodes-to-pascal/ && \
		PATH=${TMP_DIR} x3d-nodes-to-pascal nodes-specification/*.txt \
		--output-path ../../../src/x3d/auto_generated_node_helpers/

	# For reproducible builds we need to make sure the timestamp of the just
	# created files is fixed. Let's use SOURCE_DATE_EPOCH for that. For the
	# future, this needs to be even smarter, because now every Debian revision
	# will require all the reverse dependencies generating ppu files to be
	# rebuild.
	touch --no-dereference --date="@$${SOURCE_DATE_EPOCH}" \
		src/x3d/auto_generated_node_helpers/*.inc \
		src/fonts/castletexturefont_*.pas \
		src/ui/opengl/castlecontrolsimages.*

	touch prepare-source-stamp

# Annoying thing is we need to do this very early to save lots of overhead. If
# it can be done on a clean tree, right after prepare-source we don't need
# cleaning, right.
install-source: install-source-stamp
install-source-stamp:
	@echo "--- Copying the source code"
	dh_testdir
	${MKDIR} ${SRC_DIR}
	${CP} -t ${SRC_DIR} \
		$(CURDIR)/src/*
	find $(SRC_DIR) -name '*.bmp' -o -name '*.pas' -exec chmod 644 '{}' ';'
	find ${SRC_DIR} -empty -delete
	touch install-source-stamp

override_dh_auto_build-arch: prepare-source install-source
	# Build the real engine
	${MAKE} all
	# Generate man pages
	${MAKE} -C doc/man/man1

override_dh_auto_install-arch:
	# Install units
	${MKDIR} ${UNITS_DIR}
	${CP} -t ${UNITS_DIR} units/${FPCTARGET}/*
	# Mark package as manually compilable and install them
	for package in $$(find * -name '*.lpk') ; \
	do \
		pkgDir=$$(dirname "${LIB_DIR}/$${package}") ; \
		${MKDIR} "$${pkgDir}" ; \
		sed -e 's@\(\W*\)<CompilerOptions>.*@\1<AutoUpdate Value="Manually"/>\n&@' \
		    -e "s@\.\./src/@$$(relpath ${SRC_DIR} $${pkgDir})/@g" \
		    -e "s@\(\W*\)<UnitOutputDirectory .*@<UnitOutputDirectory Value=\"$$(relpath ${UNITS_DIR} $${pkgDir})\"/>@" \
		    "$${package}" > "${LIB_DIR}/$${package}" ; \
	done
	# Call upstream install target for the tools
	${MAKE} PREFIX=${INSTALL_DIR}/usr install
	find ${INSTALL_DIR} -empty -delete

override_dh_auto_build-indep: prepare-source install-source
	@echo "--- Building Documentation"
	# Create logo first, before generating documentation
	${MAKE} -C doc/pasdoc/logo
	${MAKE} -C doc/pasdoc ${DOCTYPE}
	# pasdoc create a jquery file, but we link from jquery instead
	${RM} doc/reference/tipuesearch/jquery.min.js

override_dh_auto_install-indep: install-source

override_dh_installdocs:
	dh_installdocs -X.in

override_dh_install:
	# tmp/tmp is used for the testsuite
	dh_install -Xtmp/tmp/

override_dh_compress-indep:
	dh_compress -X.pdf

.PHONY:prepare-source install-source
